﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'xKCButton CustomView Class
'Version 1.0
'Author Klaus CHRISTL (klaus)

#Event: Click
#RaisesSynchronousEvents: Click

#DesignerProperty: Key: TooltipText, DisplayName: TooltipText, FieldType: String, DefaultValue: , Description: Icon file name
#DesignerProperty: Key: IconFileName, DisplayName: IconFileName, FieldType: String, DefaultValue: , Description: Icon file name

Sub Class_Globals
	Private xui As XUI 'ignore

	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase, mParent, mDummy As B4XView 'ignore
	Private imvButton As B4XView
	Private lblTooltip As B4XView
	
	Private mLeft, mTop, mWidth, mHeight As Int
	
	Private mIconFileName, mTooltipText As String
	
	Private mTag As Object
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mDummy = Base
	mTag = mDummy.Tag
	mLeft = mDummy.Left
	mTop = mDummy.Top
	mWidth = mDummy.Width
	mHeight = mDummy.Height
	mBase = xui.CreatePanel("mBase")
	
	mParent = mDummy.Parent
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)
	mDummy.RemoveViewFromParent
	
	mIconFileName = Props.Get("IconFileName")
	mTooltipText = Props.Get("TooltipText")
	
	InitButton
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Private Sub InitButton
	Private imv As ImageView
	imv.Initialize("")
	imvButton = imv
	mBase.AddView(imvButton, 0, 0, mWidth, mHeight)
	SetIconBitmap(0)
End Sub

Private Sub mBase_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case mBase.TOUCH_ACTION_DOWN
			SetIconBitmap(1)
			Tooltip(mTooltipText)
		Case mBase.TOUCH_ACTION_MOVE
			If x > 0 And x < mWidth And y > 0 And y < mHeight Then
'				SetIconBitmap(1)
				Tooltip(mTooltipText)
			Else
'				SetIconBitmap(0)
				Tooltip("Do nothing")
			End If
		Case mBase.TOUCH_ACTION_UP
			SetIconBitmap(0)
			If x > 0 And x < mWidth And y > 0 And y < mHeight Then
				If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
					CallSub(mCallBack, mEventName & "_Click")
				End If
			End If
			Tooltip("")
	End Select
End Sub

'sets or gets the generic icon filename 
'the xButton needs two image files.
'the generic name: MyName
'MyName0.png for unchecked and MyName1.png for checked
Public Sub setBitmapFileName(IconFileName As String)
	mIconFileName = IconFileName
	SetIconBitmap(0)
End Sub

Public Sub SetIconBitmap(Index As Int)
	imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & Index & ".png"))
End Sub

'sets pr gets the Tag property
Public Sub setTag(Tag As Object)
	mTag = Tag
End Sub

Public Sub getTag As Object
	Return mTag
End Sub

'sets pr gets the Visible property
Public Sub setVisible(Visible As Boolean)
	mBase.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

'sets the tooltip label
Public Sub setTooltipLabel(TooltipLabel As B4XView)
	lblTooltip = TooltipLabel
End Sub

Public Sub getTooltipLabel As B4XView
	Return lblTooltip
End Sub

Private Sub Tooltip(Text As String)
	If lblTooltip.IsInitialized Then
		If Text = "" Then
			lblTooltip.Visible = False
		Else
			lblTooltip.Text = Text
			lblTooltip.Visible = True
		End If
	End If
End Sub