﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.98
@EndOfDesignText@
'xScrollBar CustomView Class
'Version 1.0
'Author Klaus CHRISTL (klaus)
#DesignerProperty: Key: Orientation, DisplayName: Orientation, FieldType: String, DefaultValue: Vertical, List: Vertical|Horizontal, Description: Orientation of the ScrollBar.
#DesignerProperty: Key: MinValue, DisplayName: MinValue, FieldType: Int, DefaultValue: 0, Description: Min value, left position.
#DesignerProperty: Key: MaxValue, DisplayName: MaxValue, FieldType: Int, DefaultValue: 100, Description: Max value, right position.
#DesignerProperty: Key: RelativeCursorLength, DisplayName: CursorLength, FieldType: Int, DefaultValue: 100, Description: Cursor length in percent of the total ScrollBar width.
#DesignerProperty: Key: BackgroundColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xFFDCDCDC, Description: ScrollBar background color.
#DesignerProperty: Key: FrameColor, DisplayName: FrameColor, FieldType: Color, DefaultValue: 0xFF808080, Description: ScrollBar frame color.
#DesignerProperty: Key: CursorColor, DisplayName: CursorColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color of the cursor.
#DesignerProperty: Key: CursorFrameColor, DisplayName: CursorFrameColor, FieldType: Color, DefaultValue: 0xFF808080, Description: Color of the cursor frame.
#DesignerProperty: Key: ButtonColor, DisplayName: ButtonColor, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color of the button.
#DesignerProperty: Key: ButtonFrameColor, DisplayName: ButtonFrameColor, FieldType: Color, DefaultValue: 0xFF808080, Description: Color of the button frame.
#DesignerProperty: Key: ButtonArrowColor, DisplayName: ButtonArrowColor, FieldType: Color, DefaultValue: 0xFF808080, Description: Color of the button arrows.

#Event: ValueChange(Position As Int)
#RaisesSynchronousEvents: ValueChange(Position As Int)

Sub Class_Globals
	Private xui As XUI 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As B4XView 'ignore
	Private mBase As B4XView 'ignore
	
	Private btnLeftTop, btnRightBottom, pnlBackground, pnlCursor As B4XView
	Private cvsLeftTop, cvsRightBottom As B4XCanvas
	
	Private mLeft, mTop, mWidth, mHeight, mButtonWidth, mBarLength, mCursorWidth, mCursorLength, mCursorMode, Cursor0, LeftTop0, CursorPosition As Int
	
	Private mOrientation = "Vertical" As String
	Private mBackgroundColor, mFrameColor, mCursorColor, mCursorFrameColor, mButtonColor, mButtonFrameColor, mButtonArrowColor  As Int
	
	Private mMinValue, mMaxValue, mRelativeCursorLength As Int
	Private mShortStep, mLongStep As Int
	Private mVisible = True As Boolean
	Private mTag As Object
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	mBackgroundColor = 0xFFDCDCDC
	mCursorColor = 0xFFFFFFFF
	mCursorFrameColor = 0xFF808080
	mButtonColor = 0xFFFFFFFF
	mButtonFrameColor = 0xFF808080
	mButtonArrowColor = 0xFF808080
	mFrameColor = 0xFF808080

End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mLeft = mBase.Left
	mTop = mBase.Top
	mWidth = mBase.Width
	mHeight = mBase.Height
	mButtonWidth = Min(mWidth, mHeight)
	mBarLength = Max(mWidth, mHeight)
	mCursorWidth = 2 * mButtonWidth
	mCursorLength = mBarLength - 2 * mButtonWidth
	
	mVisible = mBase.Visible
	mTag = mBase.Tag
	
	mOrientation = Props.Get("Orientation")
	mBackgroundColor = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	mCursorColor = xui.PaintOrColorToColor(Props.Get("CursorColor"))
	mCursorFrameColor = xui.PaintOrColorToColor(Props.Get("CursorFrameColor"))
	mButtonColor = xui.PaintOrColorToColor(Props.Get("ButtonColor"))
	mButtonFrameColor = xui.PaintOrColorToColor(Props.Get("ButtonFrameColor"))
	mButtonArrowColor = xui.PaintOrColorToColor(Props.Get("ButtonArrowColor"))
	mFrameColor = xui.PaintOrColorToColor(Props.Get("FrameColor"))
	
	InitScrollBar
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
 
End Sub

Private Sub InitScrollBar
	pnlBackground = xui.CreatePanel("pnlBackground")
	pnlBackground.SetColorAndBorder(mBackgroundColor, 0, mFrameColor, 0)
	
	pnlCursor = xui.CreatePanel("")
	pnlCursor.SetColorAndBorder(mCursorColor, 1, mCursorFrameColor, 0)

	btnLeftTop = xui.CreatePanel("btnLeftTop")
	cvsLeftTop.Initialize(btnLeftTop)
	btnLeftTop.SetColorAndBorder(mButtonColor, 1, mButtonFrameColor, 0)
	
	btnRightBottom = xui.CreatePanel("btnRightBottom")
	btnRightBottom.SetColorAndBorder(mButtonColor, 1, mButtonFrameColor, 0)
	cvsRightBottom.Initialize(btnRightBottom)

	If mOrientation = "Vertical" Then
		mBase.AddView(pnlBackground, 0, mButtonWidth, mButtonWidth, mCursorLength)
		pnlBackground.AddView(pnlCursor, 0, 0, mButtonWidth, 2 * mButtonWidth)
		mBase.AddView(btnLeftTop, 0, 0, mButtonWidth, mButtonWidth)
		mBase.AddView(btnRightBottom, 0, mBarLength - mButtonWidth, mButtonWidth, mButtonWidth)
	Else
		mBase.AddView(pnlBackground, mButtonWidth, 0, mCursorLength, mButtonWidth)
		pnlBackground.AddView(pnlCursor, 0, 0, 2 * mButtonWidth, mButtonWidth)
		mBase.AddView(btnLeftTop, 0, 0, mButtonWidth, mButtonWidth)
		mBase.AddView(btnRightBottom, mBarLength - mButtonWidth, 0, mButtonWidth, mButtonWidth)
	End If
	
'	DrawButtons
End Sub

Private Sub DrawButtons
	Private mPath As B4XPath
	Private mRect As B4XRect
	
	Private cTop, cLeft, cBottom, cMid As Int
	
	cTop = 0.4 * mButtonWidth
	cBottom = 0.7 * mButtonWidth
	cLeft = 0.2 * mButtonWidth
	cMid = 0.5 * mButtonWidth
	mRect.Initialize(0, 0, mButtonWidth, mButtonWidth)
	If mOrientation = "Vertical" Then
		cvsLeftTop.DrawRect(mRect, xui.Color_Red, True, 1)
		cvsLeftTop.DrawRect(mRect, mButtonArrowColor, False, 2)
		
		mPath.Initialize(cLeft, mButtonWidth - cTop)
		mPath.LineTo(mButtonWidth - cLeft, mButtonWidth - cTop)
		mPath.LineTo(cMid, mButtonWidth - cBottom)
		cvsLeftTop.DrawPath(mPath, mButtonArrowColor, True, 1)
		
		mPath.Initialize(cLeft, cTop)
		mPath.LineTo(mButtonWidth - cLeft, cTop)
		mPath.LineTo(cMid, cBottom)
		cvsRightBottom.DrawPath(mPath, mButtonArrowColor, True, 1)
	Else
		mPath.Initialize(mButtonWidth - cBottom, cMid)
		mPath.LineTo(mButtonWidth - cTop, cLeft)
		mPath.LineTo(mButtonWidth - cTop, mButtonWidth - cLeft)
		cvsLeftTop.DrawPath(mPath, mButtonArrowColor, True, 1)

		mPath.Initialize(cBottom, cMid)
		mPath.LineTo(cTop, cLeft)
		mPath.LineTo(cTop, mButtonWidth - cLeft)
		cvsRightBottom.DrawPath(mPath, mButtonArrowColor, True, 1)
	End If
End Sub

Private Sub pnlBackground_Touch (Action As Int, X As Float, Y As Float)
	If mOrientation = "Vertical" Then
		Select Action
			Case pnlBackground.TOUCH_ACTION_DOWN
				If Y < pnlCursor.Top Then
					mCursorMode = 0
				Else If Y >= pnlCursor.Top And Y < pnlCursor.Top + mCursorWidth Then
					mCursorMode = 2
				Else
					mCursorMode = 1
				End If
				Cursor0 = Y
				LeftTop0 = pnlCursor.Top
			Case pnlBackground.TOUCH_ACTION_MOVE
				If mCursorMode = 2 Then
					CursorPosition = LeftTop0 + (Y - Cursor0)
					CursorPosition = Max(0, CursorPosition)
					CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
					Change
				End If
				pnlCursor.Top = CursorPosition
			Case pnlBackground.TOUCH_ACTION_UP
				Select mCursorMode
					Case 0
						CursorPosition = CursorPosition - mCursorWidth / 2
					Case 1
						CursorPosition = CursorPosition + mCursorWidth / 2
					Case 2
				End Select
				CursorPosition = Max(0, CursorPosition)
				CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
				pnlCursor.Top = CursorPosition
		End Select
	Else	'mOrientation = "Vertical"
		Select Action
			Case pnlBackground.TOUCH_ACTION_DOWN
				If X < pnlCursor.Left Then
					mCursorMode = 0
				Else If X >= pnlCursor.Left And X < pnlCursor.Left + mCursorWidth Then
					mCursorMode = 2
				Else
					mCursorMode = 1
				End If
				Cursor0 = X
				LeftTop0 = pnlCursor.Left
			Case pnlBackground.TOUCH_ACTION_MOVE
				If mCursorMode = 2 Then
					CursorPosition = LeftTop0 + (X - Cursor0)
					CursorPosition = Max(0, CursorPosition)
					CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
					Change
				End If
				pnlCursor.Left = CursorPosition
			Case pnlBackground.TOUCH_ACTION_UP
				Select mCursorMode
					Case 0
						CursorPosition = CursorPosition - mLongStep
					Case 1
						CursorPosition = CursorPosition + mLongStep
					Case 2
				End Select
				CursorPosition = Max(0, CursorPosition)
				CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
				pnlCursor.Left = CursorPosition
				Change
		End Select
	End If
End Sub

Private Sub btnLeftTop_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case pnlBackground.TOUCH_ACTION_DOWN
			CursorPosition = CursorPosition - mLongStep
			CursorPosition = Max(0, CursorPosition)
			CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
			If mOrientation = "Vertical" Then
				pnlCursor.Top = CursorPosition
			Else
				pnlCursor.Left = CursorPosition
			End If			Change
	End Select
End Sub

Private Sub btnRightBottom_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case pnlBackground.TOUCH_ACTION_DOWN
			CursorPosition = CursorPosition + mLongStep
			CursorPosition = Max(0, CursorPosition)
			CursorPosition = Min(mCursorLength - mCursorWidth, CursorPosition)
			If mOrientation = "Vertical" Then
				pnlCursor.Top = CursorPosition
			Else
				pnlCursor.Left = CursorPosition
			End If
			Change
	End Select
End Sub

Private Sub Change
	If xui.SubExists(mCallBack, mEventName & "_ValueChange", 0) Then
		CallSubDelayed2(mCallBack, mEventName & "_ValueChange", CursorPosition)
	End If
End Sub

'gets or sets the MinValue property
'It is the most left / top position
Public Sub setMinValue(MinValue As Int)
	mMinValue = MinValue
End Sub

Public Sub getMinValue As Int
	Return mMinValue
End Sub

'gets or sets the MaxValue property
'It is the most right / bottom position
Public Sub setMaxValue(MaxValue As Int)
	mMaxValue = MaxValue
End Sub

Public Sub getMaxValue As Int
	Return mMaxValue
End Sub

'gets Or sets the RelativeCursorLength property
'relative cursour length in percent of the total length
Public Sub setRelativeCursorLength(RelativeCursorLength As Int)
	mRelativeCursorLength = RelativeCursorLength
	mCursorWidth = mCursorLength * mRelativeCursorLength / 100
	If mOrientation = "Vertical" Then
		pnlCursor.Height = mCursorWidth
	Else
		pnlCursor.Width = mCursorWidth
	End If
End Sub

Public Sub getRelativeCursorLength As Int
	Return mRelativeCursorLength
End Sub

'gets or sets the ShortStep property
'It is the step moved when clicking on the Left/Top or Right/Bottom button
Public Sub setShortStep(ShortStep As Int)
	mShortStep = ShortStep
End Sub

Public Sub getShortStep As Int
	Return mShortStep
End Sub

'gets or sets the LongStep property
'It is the step moved when clicking on the left or right of the cursor
Public Sub setLongStep(LongStep As Int)
	mLongStep = LongStep
End Sub

Public Sub getLongStep As Int
	Return mLongStep
End Sub

'gets or sets the Left property
Public Sub setLeft(Left As Int)
	mLeft = Left
	mBase.Left = mLeft
End Sub

Public Sub getLeft As Int
	Return mLeft
End Sub

'gets or sets the Top property
Public Sub setTop(Top As Int)
	mTop = Top
	mBase.Top = mTop
End Sub

Public Sub getTop As Int
	Return mTop
End Sub

'gets or sets the Width property
Public Sub setWidth(Width As Int)
	mWidth = Width
	mBase.Width = mWidth
End Sub

Public Sub getWidth As Int
	Return mWidth
End Sub

'gets or sets the Height property
Public Sub setHeight(Height As Int)
	mHeight = Height
	mBase.Height = mHeight
End Sub

Public Sub getHeight As Int
	Return mHeight
End Sub

'gets or sets the Visible property
Public Sub setVisible(Visible As Boolean)
	mVisible = Visible
	mBase.Visible = mVisible
End Sub

Public Sub getVisible As Boolean
	Return mVisible
End Sub

'gets or sets the Tag property
Public Sub setTag(Tag As Int)
	mTag = Tag
End Sub

Public Sub getTag As Int
	Return mTag
End Sub

