﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'xKCToggleButton CustomView Class
'Version 1.0
'Author Klaus CHRISTL (klaus)

#Event: Checked(Checked As Boolean)
#RaisesSynchronousEvents: Checked

#DesignerProperty: Key: TooltipText, DisplayName: TooltipText, FieldType: String, DefaultValue: , Description: Icon file name
#DesignerProperty: Key: IconFileName, DisplayName: IconFileName, FieldType: String, DefaultValue: , Description: Icon file name
#DesignerProperty: Key: Checked, DisplayName: Checked, FieldType: Boolean, DefaultValue: False, Description: Checked
#DesignerProperty: Key: RadioButton, DisplayName: RadioButton, FieldType: Boolean, DefaultValue: False, Description: Used like a RadioButton.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase, mParent, mDummy As B4XView 'ignore
	Private imvButton As B4XView
	Private lblTooltip As B4XView
	
	Private mLeft, mTop, mWidth, mHeight As Int
	Private xui As XUI 'ignor
	
	Private mIconFileName, mTooltipText As String
	Private mChecked, mRadioButton As Boolean
	
	Private mTag As Object
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mDummy = Base
	mTag = mDummy.Tag
	mLeft = mDummy.Left
	mTop = mDummy.Top
	mWidth = mDummy.Width
	mHeight = mDummy.Height
	mBase = xui.CreatePanel("mBase")
	
	mParent = mDummy.Parent
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)
	mDummy.RemoveViewFromParent
	
	mIconFileName = Props.Get("IconFileName")
	mTooltipText = Props.Get("TooltipText")
	mChecked = Props.Get("Checked")
	mRadioButton = Props.Get("RadioButton")
	
	InitButton
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Private Sub InitButton
	Private imv As ImageView
	imv.Initialize("")
	imvButton = imv
	mBase.AddView(imvButton, 0, 0, mWidth, mHeight)
	SetIconBitmap
End Sub

Private Sub mBase_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case mBase.TOUCH_ACTION_DOWN
			Tooltip(mTooltipText)
			If mChecked = False Then
				imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "1.png"))
			Else
				imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "0.png"))
			End If
		Case mBase.TOUCH_ACTION_MOVE
			If x > 0 And x < mWidth And y > 0 And y < mHeight Then
'				SetIconBitmap(1)
				Tooltip(mTooltipText)
			Else
'				SetIconBitmap(0)
				Tooltip("Do nothing")
			End If		
			Case mBase.TOUCH_ACTION_UP
			If X > 0 And X < mWidth And Y > 0 And Y < mHeight Then
				If mRadioButton = True Then
					mChecked = True
				Else
					mChecked = Not(mChecked)
				End If
			End If
			SetIconBitmap
			If xui.SubExists(mCallBack, mEventName & "_Checked", 1) Then
				CallSub2(mCallBack, mEventName & "_Checked", mChecked)
			End If
			Tooltip("")
	End Select
End Sub

'sets or gets the generic icon filename 
'the xToggleButton needs two image files.
'the generic name: MyName
'MyName0.png for unchecked and MyName1.png for checked
Public Sub setBitmapFileName(IconFileName As String)
	mIconFileName = IconFileName
	SetIconBitmap
End Sub

Public Sub SetIconBitmap
	If mChecked = False Then
		imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "0.png"))
	Else
		imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "1.png"))
	End If
End Sub

'sets pr gets the Checked property
Public Sub setChecked(Checked As Boolean)
	mChecked = Checked
	If mChecked = False Then
		imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "0.png"))
	Else
		imvButton.SetBitmap(xui.LoadBitmap(File.DirAssets, mIconFileName & "1.png"))
	End If
End Sub

Public Sub getChecked As Boolean
	Return mChecked
End Sub

'sets pr gets the Tag property
Public Sub setTag(Tag As Object)
	mTag = Tag
End Sub

Public Sub getTag As Object
	Return mTag
End Sub

'sets pr gets the Visible property
Public Sub setVisible(Visible As Boolean)
	mBase.Visible = Visible
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

'sets the tooltip label
Public Sub setTooltipLabel(TooltipLabel As B4XView)
	lblTooltip = TooltipLabel
End Sub

Public Sub getTooltipLabel As B4XView
	Return lblTooltip
End Sub

Private Sub Tooltip(Text As String)
	If lblTooltip.IsInitialized Then
		If Text = "" Then
			lblTooltip.Visible = False
		Else
			lblTooltip.Text = Text
			lblTooltip.Visible = True
		End If
	End If
End Sub